obj = {}
local obj_m = {__index = obj}

function obj.new(type, x, y, width, height, color, fall_speed)
	color = color or {0, 255, 100, 255}
	fall_speed = fall_speed or screen.height / 64
	local o = {
			x = x,
			y = y,
			width = width,
			height = height,
			color = color,
			remove = false,
			removed = false,
			scale = 1,
			alpha = 1,
			fade_speed = 8,
			fall_speed = fall_speed,
			type = type
		}
	return setmetatable(o, obj_m)
end

function obj:get()
	return self
end

function obj:update(dt)
	if not self.remove and not game.pause and not game.lost and not game.won then
		self.y = self.y + self.fall_speed * dt
	else
		if not self.removed then
			self.scale = self.scale - self.fade_speed * dt
			self.alpha = self.alpha - self.fade_speed * dt
			self.color[3] = 255 * self.alpha 
			self.color[4] = 255 * self.alpha
			if self.scale < 0  then 
				self.scale = 0
				self.removed = true
			end
		end
	end
end

function obj:draw()
	love.graphics.setColor(hsl(self.color))
	love.graphics.rectangle("line", self.x - ((self.width / 2) * self.scale) + (self.width / 2), self.y - ((self.height / 2) * self.scale) + (self.height / 2), self.width * self.scale, self.height * self.scale)
end